MODULE PointO EXPORTS PointO;

(* Implementierung der Point0 Klasse.
Autor : Horst Lichter, RWTH Aachen
Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 4.0
Erstellt : 16.08.98
Letzte Aenderung: 09.01.2001
*)

IMPORT Fmt;

REVEAL
  T = PublicPoint BRANDED OBJECT (* Objekt bekommt Instanzvariablen *)
        x : INTEGER;
        y : INTEGER;
      OVERRIDES			(* Methoden werden redefiniert *)
        setX := SetX;
        getX := GetX;
        setY := SetY;
        getY := GetY;
        add := Add;
        minus := Minus;
        asText := AsText;
      END; 

PROCEDURE AsText (self : T) : TEXT =
(* Gibt den x und y wert als TEXT zurck *)
BEGIN
  RETURN (Fmt.Int(self.x)  &  "&"  &  Fmt.Int(self.y));
END AsText;

PROCEDURE GetX(self : T): INTEGER =
(* Gibt den mit SetX gesetzten wert aus *)
BEGIN
  RETURN self.x;
END GetX;

PROCEDURE GetY(self : T): INTEGER =
(* Gibt den mit SetY gesetzten wert aus *)
BEGIN
  RETURN self.y;
END GetY;

PROCEDURE SetX(self: T; value : INTEGER) =
(* setzt den X wert *)
BEGIN
  self.x := value;
END SetX;

PROCEDURE SetY(self: T; value : INTEGER) =
(* setzt den y wert *)
BEGIN
  self.y := value;
END SetY;

PROCEDURE Add (self: T; p: T) : T =
(* Addiert den x und y wert der Objekte p und self (aufrufendes Modul) *)
VAR newP : T;
BEGIN
  newP := NEW(T);
  newP.setX(self.x + p.getX());
  newP.setY(self.y + p.getY());
  RETURN newP;
END Add;

PROCEDURE Minus (self: T; p: T) : T =
(* Subtrahiert den x und y wert des Objekts p von dem x und y Wert von self (aufrufendes Modul) *)
VAR newP : T;
BEGIN
  newP := NEW(T);
  newP.setX(self.x - p.getX());
  newP.setY(self.y - p.getY());
  RETURN newP;
END Minus;

BEGIN
END PointO.