MODULE Chiffre EXPORTS Main;

(* Dieses Programm chiffriert einen vorgegebenen Text.
   Autor           : Moritz Schnizler, RWTH Aachen
   Umgebung        : SRC-Modula-3 rel. 3.6, Windows NT 4.0
   Erstellt        : 11.11.98   Letzte Aenderung: 20.11.00 *)

IMPORT SIO;  (* Importiere vordefinierte Ein-/Ausgabefunktionen *)
IMPORT Text; (* Importiere Textoperationen *)


PROCEDURE ChiffriereZeichen(c: CHAR): CHAR =
(* Chiffriert das uebergebene Zeichen gemaess Vorschrift *)

VAR ergebnisz: CHAR;
BEGIN
  CASE c OF
    'A'..'Z' => ergebnisz := ErsetzeZeichen(c, 'A', 'Z', 3);  (* 3. Nachfolger *)
  | 'a'..'z' => ergebnisz := ErsetzeZeichen(c, 'a', 'z', -2); (* 2. Vorgaenger *)
  | '0'..'9' => ergebnisz := ErsetzeZeichen(c, '0', '9', 5);  (* 5. Nachfolger *)
  ELSE
    ergebnisz := c; (* Keine Aenderung *)
  END;

  RETURN ergebnisz;
END ChiffriereZeichen;


PROCEDURE ErsetzeZeichen(c: CHAR; startz: CHAR; endz: CHAR; 
                         index: INTEGER): CHAR =
(* Ersetzt Zeichen c durch das um index verschobene Zeichen modulo die 
   Laenge des Wertebereichs zwischen den Zeichen startz und endz. *)

VAR laenge     : CARDINAL;
    zeichenwert: CARDINAL;
BEGIN
  (* Berechne Laenge des Wertebereichs *)
  laenge := ORD(endz) - ORD(startz) + 1; 

  (* Wandle c in Ordinalwert und nehme Verschiebung vor *)
  zeichenwert := ORD(c) - ORD(startz);
  zeichenwert := (zeichenwert + index) MOD laenge;

  (* Korrigiere Ordinalwert bezueglich Startzeichen *)
  zeichenwert := zeichenwert + ORD(startz);

  (* Gib Ordinalwert als Zeichen vom Typ CHAR zurueck *)
  RETURN VAL(zeichenwert, CHAR);
END ErsetzeZeichen;


PROCEDURE ChiffriereText(t: TEXT): TEXT =
(* Gibt den uebergebenen Text chiffriert zurueck *)

VAR ergebnisText: TEXT := "";
    zeichenText : TEXT;
BEGIN
  FOR i := 0 TO (Text.Length(t) - 1)  DO
    zeichenText := Text.FromChar(ChiffriereZeichen(Text.GetChar(t, i)));
    ergebnisText := ergebnisText & zeichenText;                   
  END;

  RETURN ergebnisText;
END ChiffriereText;

BEGIN
  SIO.PutText("Geben Sie einen Text ein: ");
  SIO.PutLine(ChiffriereText(SIO.GetLine()));
END Chiffre.
