MODULE Waehrung;

(* Schnittstelle eines ADTs fuer Waehrungen.
   Autor           : Antje Nowack
   Umgebung  : PM3, Windows 95
   Erstellt        : 04. 01. 2001  Letzte Aenderung: 09.01. 2001 *)


TYPE REVEAL T = BRANDED REF RECORD
                  bezeichnung: TEXT;
                  kurs       : REAL;   
                END;


(* Stand der Waehrungkurse: 09. 01. 2001 *)

PROCEDURE ErzeugeCHF(): T=
(* Erzeugt ein Element des Typs fuer die Waehrung CHF. *)
VAR neueWaehrung: T;

BEGIN
  neueWaehrung              := NEW(T);
  neueWaehrung^.bezeichnung := "CHF";
  neueWaehrung^.kurs        := 1.528781; 

  RETURN neueWaehrung;
END ErzeugeCHF;


PROCEDURE ErzeugeDM(): T=
(* Erzeugt ein Element des Typs fuer die Waehrung DM. *)
VAR neueWaehrung: T;

BEGIN
  neueWaehrung              := NEW(T);
  neueWaehrung^.bezeichnung := "DM";
  neueWaehrung^.kurs        := 1.956229;

  RETURN neueWaehrung;
END ErzeugeDM;


PROCEDURE ErzeugeEUR(): T=
(* Erzeugt eine Element des Typs fuer die Waehrung EUR. *)
VAR neueWaehrung: T;

BEGIN
  neueWaehrung              := NEW(T);
  neueWaehrung^.bezeichnung := "EUR";
  neueWaehrung^.kurs        := 1.00;

  RETURN neueWaehrung;
END ErzeugeEUR;
 

PROCEDURE ErzeugeFF(): T=
(* Erzeugt eine Element des Typs fuer die Waehrung FF. *)
VAR neueWaehrung: T;

BEGIN
  neueWaehrung              := NEW(T);
  neueWaehrung^.bezeichnung := "FF";
  neueWaehrung^.kurs        := 6.560979;

  RETURN neueWaehrung;
END ErzeugeFF;


PROCEDURE ErzeugeGBP(): T=
(* Erzeugt ein Element des Typs fuer die Waehrung GBP. *)
VAR neueWaehrung: T;

BEGIN
  neueWaehrung              := NEW(T);
  neueWaehrung^.bezeichnung := "GBP";
  neueWaehrung^.kurs        := 0.633604; 

  RETURN neueWaehrung;
END ErzeugeGBP;


PROCEDURE ErzeugeUSD(): T=
(* Erzeugt ein Element des Typs fuer die Waehrung USD. *)
VAR neueWaehrung: T;

BEGIN
  neueWaehrung              := NEW(T);
  neueWaehrung^.bezeichnung := "USD";
  neueWaehrung^.kurs        := 0.953200; 

  RETURN neueWaehrung;
END ErzeugeUSD;


PROCEDURE GibBezeichnung(waehrung: T): TEXT=
(* Gibt die Bezeichnung der als Parameter gegebenen Waehrung zurueck. *)
BEGIN
  RETURN waehrung^.bezeichnung;
END GibBezeichnung;


PROCEDURE GibKurs(waehrung: T): REAL=
(* Gibt den Kurs der als Parameter gegebenen Waehrung zurueck. *)
BEGIN
  RETURN waehrung^.kurs;
END GibKurs;

BEGIN
END Waehrung.