INTERFACE Assertion;

EXCEPTION Violated; (* Ausnahme Violated wird generiert, wenn eine Zusicherung verletzt wird. *)
          Terminate;            

PROCEDURE Require (expr : BOOLEAN; procName: TEXT) RAISES {Violated};
(* Prueft die im Ausdruck expr gegebene Vorbedingung und erzeugt bei Ergebnis
   FALSE die Ausnahme Violated mit einer durch procName parametrisierten
   Fehlermeldung. *)


PROCEDURE Ensure (expr : BOOLEAN; procName: TEXT) RAISES {Violated};
(* Prueft die im Ausdruck expr gegebene Nachbedingung (Invariante) und erzeugt
   bei Ergebnis FALSE die Ausnahme Violated mit einer durch procName 
   parametrisierten Fehlermeldung. *)


PROCEDURE EnableAssertions();
(* Schaltet Pruefung der Zusicherungen ein. *)


PROCEDURE DisableAssertions();
(* Schaltet Pruefung der Zusicherungen aus. *)


END Assertion.