MODULE CDVerwaltung EXPORTS Main;

(* Schnittstelle des abstrakten Datentyps CD.
   Autor           : Thomas von der Maen, RWTH Aachen
   Umgebung        : PM-3 Windows 2000
   Erstellt        : 19.12.00  Letzte Aenderung: 02.01.01 
*)

IMPORT SIO;
IMPORT Diskographie;  (* Importiere ADO Diskographie *)
IMPORT CD;            (* Importiere ADT CD *)
IMPORT Track;         (* Importiere ADT Track *)

VAR dummy : TEXT;
    auswahl : CHAR;
    cd : CD.T;
    track: Track.T;
    nummer: CARDINAL;


PROCEDURE PrintMenu()=
(* Hilfsprozedur, die das Befehlsmenue ausgibt *)
BEGIN
  SIO.Nl();
  SIO.PutLine("F : Fuege neue CD ein");
  SIO.PutLine("L : Loesche CD");
  SIO.PutLine("Z : Zeige Diskographie an");
  SIO.PutLine("T : Fuege Track in CD ein");
  SIO.PutLine("X : Loesche Track von CD");
  SIO.PutLine("E : Exit");
  SIO.Nl();
END PrintMenu;


BEGIN
  Diskographie.Init();   (* Initialisiere die Diskographie *)

  REPEAT
    PrintMenu();
    
    (* Frage Benutzer nach seiner Auswahl *)
    SIO.PutText("Auswahl: ");
    auswahl := SIO.GetChar();
    dummy := SIO.GetLine(); (* Lies RETURN aus dem Eingabepuffer! *)
    SIO.Nl();

    CASE auswahl OF
    (* Erstellt eine neue CD *)
    |  'F', 'f' => cd := CD.CreateCD();
                   SIO.PutText("Bitte geben Sie den CD-Titel ein: ");
                   CD.SetTitle(cd, SIO.GetLine());
                   SIO.PutText("Bitte geben Sie den Interpreten ein: ");
                   CD.SetInterpret(cd, SIO.GetLine());
                   Diskographie.AddCD(cd);

    (* Lschen der letzten CD *)                   
    |  'L', 'l' => Diskographie.Print();
                   SIO.PutText("Geben Sie die CD-Nummer ein: ");
                   nummer := SIO.GetInt();
                   dummy := SIO.GetLine();
                   Diskographie.RemoveCD(nummer)
                  
    (* Ausgeben der aktuellen Diskographie *)
    |  'Z', 'z' => Diskographie.PrintWithTracklist();

    (* Einen Track einer CD hinzufgen *)
    |  'T', 't' => Diskographie.Print();
                   SIO.PutText("Geben Sie die CD-Nummer ein: ");
                   nummer := SIO.GetInt();
                   dummy := SIO.GetLine();
                   cd := Diskographie.GetCD(nummer);
                   IF (cd # NIL) THEN
                     REPEAT
                       track := Track.CreateTrack();
                       SIO.PutText("Geben sie den Namen des Tracks ein: ");
                       Track.SetName(track, SIO.GetLine());
                       SIO.PutText("Geben Sie die Laenge des Tracks in Sekunden ein: ");
                       Track.SetLength(track, SIO.GetInt());
                       dummy := SIO.GetLine();
                       CD.AddTrack(cd, track);
                       SIO.PutText("Moechten Sie einen weiteren Track eingeben (j/n)?");
                       auswahl := SIO.GetChar();
                       dummy := SIO.GetLine();
                     UNTIL (auswahl = 'n') OR (auswahl = 'N');
                   END;                 

    (* Einen Track von einer CD lschen *)
    |  'X', 'x' => Diskographie.Print();
                   SIO.PutText("Geben Sie die CD-Nummer ein: ");
                   nummer := SIO.GetInt();
                   dummy := SIO.GetLine();
                   cd := Diskographie.GetCD(nummer);
                   IF (cd # NIL) THEN
                     REPEAT
                       CD.RemoveTrack(cd);
                       SIO.PutText("Moechten Sie einen weiteren Track loeschen (j/n)?");
                       auswahl := SIO.GetChar();
                       dummy := SIO.GetLine();
                     UNTIL (auswahl = 'n') OR (auswahl ='N');
                   END;

    (* Das Programm beenden *)
    |  'E', 'e' => (* Nichts machen, gleich ist ohnehin alles zu Ende! *)
    ELSE
      SIO.PutLine("Ungueltiger Befehl!");
    END (* CASE *)
  UNTIL (auswahl = 'e') OR (auswahl = 'E'); 
END CDVerwaltung.