MODULE Track;

(* Modulrumpf des abstrakten Datentyps Track.
   Autor           : Thomas von der Maen, RWTH Aachen
   Umgebung        : PM-3 Windows 2000
   Erstellt        : 19.12.00  Letzte Aenderung: 02.01.01 
*)


(* Ein Track besteht aus einem Namen und der Lnge in Sekunden *)
TYPE REVEAL T = BRANDED REF RECORD
                  name: TEXT;
                  length: CARDINAL;
                END;


PROCEDURE GetName(track: T): TEXT =
(* Liefert den Namen des Tracks *)
BEGIN
  RETURN (track^.name);
END GetName;


PROCEDURE SetName(VAR track: T; n: TEXT) =
(* Setzt den Namen des Tracks auf den bergebenen String *)
BEGIN
  track^.name := n;
END SetName;


PROCEDURE GetLength(track: T): CARDINAL =
(* Liefert die Lnge des Tracks in Sekunden *)
BEGIN
  RETURN (track^.length);
END GetLength;


PROCEDURE SetLength(VAR track: T; l: CARDINAL) =
(* Setzt die Lnge des bergebenen Tracks in Sekunden *)
BEGIN
  track^.length := l;
END SetLength;


PROCEDURE CreateTrack(): T =
(* Erstellt einen neuen Track und initialisiert diesen *)
VAR newtrack: T;
BEGIN
  newtrack := NEW(T);
  newtrack^.name := "";   (* Initialisiere den Namen *)
  newtrack^.length := 0;  (* Initialisiere die Lnge *)
  RETURN newtrack;
END CreateTrack;

BEGIN
END Track.