MODULE Direkt;

(* Modul zur Klasse Direkt
   Autor           : Antje Nowack, Thomas van der Massen
   Umgebung : PM-3 Windows 95
   Erstellt        : 19.12.00  Letzte Aenderung: 22.01.01 
*)

IMPORT Tontraeger;
IMPORT Track;


REVEAL
   T = Public BRANDED OBJECT
               OVERRIDES   
                 Play := PlayerDir;
                 (* Abspielen des Tontraegers mit direktem Zugriff. Der Track an der n-ten Position der 
                   Trackliste wird zurueckgelierfert. *)
                 PrintInfo  := PrintDir;
                 (* Ausgabe aller Informationen ueber den Tontraeger als Text. Dies ist eine Redefinition der 
                    entsprechenden Methode des Typen Tontraeger. *)
               END;


PROCEDURE PlayerDir(self : T; n: CARDINAL) : Track.T =
(* Abspielen des Tontraegers mit direktem Zugriff. Der Track an der n-ten Position der Trackliste wird 
   zurueckgelierfert. *)

VAR liste: Tontraeger.Tracklist;
BEGIN
   liste := Tontraeger.T.GetTracklist(self);
   (* Suche den Track an der n-ten Stelle ... *)
   FOR i := 1 TO (n-1)  DO
       liste := liste^.next;
   END;
   (* ... und liefere diesen zurueck. *)
   RETURN liste.track;
END PlayerDir;

PROCEDURE PrintDir(self : T) : TEXT =
(* Ausgabe aller Informationen ueber den Tontraeger als Text. Dies ist eine Redefinition der entsprechenden 
   Methode des Typen Tontraeger. *)

BEGIN
(* Liefert zusaetzlich zu den Informationen, die die Methode des Supertypen Tontraeger liefert, 
   die Zugriffsart. *)

  RETURN Tontraeger.T.PrintInfo(self) & " Zugriff : Direkt" &"\n" & "    ";
END PrintDir;

BEGIN
END Direkt.
