MODULE Verwaltung EXPORTS Main;

(* Hauptprogramm zur Diskographieverwaltung
   Autor           : Antje Nowack, Thomas van der Massen
   Umgebung  : PM-3 Windows 95
   Erstellt        : 19.12.00  Letzte Aenderung: 22.01.01 
*)

IMPORT SIO;
IMPORT Diskographie;  (* Importiere ADO Diskographie *)
IMPORT Tontraeger;
IMPORT CD;            (* Importiere ADT CD *)
IMPORT Schallplatte;
IMPORT Kassette;
IMPORT Track;         (* Importiere ADT Track *)

VAR dummy : TEXT;
    auswahl : CHAR;
    cd : CD.T;
    sch : Schallplatte.T;
    kass : Kassette.T;
    tt : Tontraeger.T;
    track: Track.T;
    nummer: CARDINAL;
    disk : Diskographie.T;
    i,j : CARDINAL;


PROCEDURE PrintMenu()=
(* Hilfsprozedur, die das Befehlsmenue ausgibt *)
BEGIN
  SIO.Nl();
  SIO.PutLine("C : Fuege neue CD ein");
  SIO.PutLine("S : Fuege neue Schallplatte ein");
  SIO.PutLine("K : Fuege neue Kassette ein");
  SIO.PutLine("L : Loesche Tontraeger");
  SIO.PutLine("Z : Zeige Diskographie an");
  SIO.PutLine("T : Fuege Track in Tontraeger ein");
  SIO.PutLine("X : Loesche Track von Tontraeger");
  SIO.PutLine("P : Track von einem Tontraeger spielen");
  SIO.PutLine("B : Spule Kassette zurueck");
  SIO.PutLine("E : Exit");
  SIO.Nl();
END PrintMenu;


BEGIN
  disk := NEW(Diskographie.T);

  REPEAT
    PrintMenu();
    
    (* Frage Benutzer nach seiner Auswahl *)
    SIO.PutText("Auswahl: ");
    auswahl := SIO.GetChar();
    dummy := SIO.GetLine(); (* Lies RETURN aus dem Eingabepuffer! *)
    SIO.Nl();

    CASE auswahl OF
    (* Erstellt eine neue CD *)
    |  'c', 'C' => cd :=NEW( CD.T);
                   SIO.PutText("Bitte geben Sie den CD-Titel ein: ");
                   cd.SetTitle(SIO.GetLine());
                   SIO.PutText("Bitte geben Sie den Interpreten ein: ");
                   cd.SetInterpret(SIO.GetLine());
                   disk.AddCD(cd);

    |  's', 'S' => sch :=NEW( Schallplatte.T);
                   SIO.PutText("Bitte geben Sie den Schallplatten-Titel ein: ");
                   sch.SetTitle(SIO.GetLine());
                   SIO.PutText("Bitte geben Sie den Interpreten ein: ");
                   sch.SetInterpret(SIO.GetLine());
                   disk.AddSchallplatte(sch);


    |  'k', 'K' => kass :=NEW(Kassette.T);
                   SIO.PutText("Bitte geben Sie den Kassetten-Titel ein: ");
                   kass.SetTitle(SIO.GetLine());
                   SIO.PutText("Bitte geben Sie den Interpreten ein: ");
                   kass.SetInterpret(SIO.GetLine());
                   disk.AddKassette(kass);


   |  'L', 'l' =>  SIO.PutLine("Bitte geben Sie die Nummer des Tontraegers ein: ");
                      i := SIO.GetInt();
                     disk.RemoveTt(i); 

                 
    (* Ausgeben der aktuellen Diskographie *)
    |  'Z', 'z' => disk.PrintWithTracklist(); 

    (* Einen Track einer CD hinzufgen *)
    |  'T', 't' => Diskographie.T.Print(disk);
                   SIO.PutText("Geben Sie die Tontrager-Nummer ein: ");
                   nummer := SIO.GetInt();
                   dummy := SIO.GetLine();
                   tt := disk.GetTt(nummer);
                   IF (tt # NIL) THEN
                     REPEAT
                       SIO.PutText("Mchten Sie einen Track eingeben (j/n)?");
                       auswahl := SIO.GetChar();
                       dummy := SIO.GetLine();
                       IF (auswahl = 'j') OR (auswahl = 'J') THEN
                         track := NEW(Track.T);
                         SIO.PutText("Geben sie den Namen des Tracks ein: ");
                         track.SetName(SIO.GetLine());
                         SIO.PutText("Geben Sie die Lnge des Tracks in Sekunden ein: ");
                         track.SetLength(SIO.GetInt());
                         dummy := SIO.GetLine();
                         tt.AddTrack(track);
                       END;
                     UNTIL (auswahl = 'n') OR (auswahl = 'N');
                   END;                 


     | 'P', 'p' => Diskographie.T.Print(disk);
                   SIO.PutLine("Bitte die Nummer des Tontraegers eingeben: ");
                   i := SIO.GetInt();
                   IF disk.TypAnStelle(i) = Diskographie.TontraegerTypen.CDTyp THEN
                     cd := disk.TontraegerAnStelle(i);
                     SIO.PutLine("Bitte die Tracknummer eingeben:");
                     j := SIO.GetInt();
                     (cd.Play(j)).Print();
                   ELSIF disk.TypAnStelle(i) = Diskographie.TontraegerTypen. SchallplatteTyp THEN
                     sch := disk.TontraegerAnStelle(i);
                     SIO.PutLine("Bitte die Tracknummer eingeben:");
                     j := SIO.GetInt();
                     (sch.Play(j)).Print();
                   ELSIF disk.TypAnStelle(i) = Diskographie.TontraegerTypen. KassetteTyp THEN
                     kass := disk.TontraegerAnStelle(i);
                     IF kass.Ende() THEN SIO.PutLine("Die Kassette ist am Ende. Abspielen nicht moeglich!");
                     ELSE
                        (kass.Play()).Print();
                      END;
                   END;
    | 'B', 'b' => Diskographie.T.Print(disk);
                      SIO.PutLine("Bitte geben Sie die Nummer des Tontraegers ein");
                      i := SIO.GetInt();
                      IF disk.TypAnStelle(i) = Diskographie.TontraegerTypen. KassetteTyp  THEN
                         kass := disk.TontraegerAnStelle(i);
                         kass.Spulen();
                      ELSE
                         SIO.PutLine("Der Tontraeger hat keinen sequentiellem Zugriff!");
                      END;

    (* Das Programm beenden *)
    |  'E', 'e' => (* Nichts machen, gleich ist ohnehin alles zu Ende! *)
    ELSE
      SIO.PutLine("Ungueltiger Befehl!");
    END (* CASE *)
  UNTIL (auswahl = 'e') OR (auswahl = 'E'); 
END Verwaltung.

