MODULE Assertion;

IMPORT SIO; (* Importiere notwendige Ein-/Ausgabeoperationen *)

VAR enabled : BOOLEAN; (* Geschuetzte Variable *)


PROCEDURE Require (expr : BOOLEAN; procName: TEXT)
  RAISES {Violated} =
(* Prueft die im Ausdruck expr gegebene Vorbedingung und erzeugt bei Ergebnis
   FALSE die Ausnahme Violated mit einer durch procName parametrisierten
   Fehlermeldung. *)
BEGIN
  IF enabled AND NOT expr THEN
    SIO.PutLine("*** Precondition violated: " & procName);
    RAISE Violated;
  END;
END Require;


PROCEDURE Ensure (expr : BOOLEAN; procName: TEXT)
  RAISES {Violated} =
(* Prueft die im Ausdruck expr gegebene Nachbedingung (Invariante) und erzeugt
   bei Ergebnis FALSE die Ausnahme Violated mit einer durch procName 
   parametrisierten Fehlermeldung. *)
BEGIN
  IF enabled AND NOT expr THEN
    SIO.PutLine("*** Postcondition violated: " & procName);
    RAISE Violated;
  END;
END Ensure;


PROCEDURE EnableAssertions()=
(* Schaltet Pruefung der Zusicherungen ein. *)
BEGIN
  enabled := TRUE;
END EnableAssertions;


PROCEDURE DisableAssertions()=
(* Schaltet Pruefung der Zusicherungen aus. *)
BEGIN
  enabled := FALSE;
END DisableAssertions;


BEGIN
  EnableAssertions();
END Assertion.