MODULE BoxerRl EXPORTS Main;

(* Dieses Programm erlaubt die Verwaltung einer Tennisrangliste.
   Dazu bedient es sich der Implementierungen aus dem Objektmodul Boxen
   und des ADTs Boxer. 
   Autor           : Moritz Schnizler, Antje Nowack
   Umgebung        : PM3, Windows 95
   Erstellt        : 06.01.99  Letzte Aenderung: 15.01.2001 *)


IMPORT SIO;     (* Importiere Operationen fuer die Ein-/Ausgabe *)
IMPORT Boxer;   (* Importiere den ADT Boxer *)
IMPORT Boxen;   (* Importiere das Objektmodul Boxen *)
IMPORT Assertion AS As;

VAR boxer, gewinner, verlierer  : Boxer.T; (* Variablen des ADTs Boxer *)
    auswahl                     : CHAR;
    dummy                       : TEXT;


PROCEDURE DruckeMenue()=
(* Hilfsprozedur, die das Befehlsmenue ausgibt *)
BEGIN
  SIO.Nl();
  SIO.PutLine("F : Fuege einen Boxer ein");
  SIO.PutLine("L : Loesche einen Boxer");
  SIO.PutLine("G : Kampf gemacht");
  SIO.PutLine("Z : Zeige Rangliste an");
  SIO.PutLine("E : Exit");
  SIO.Nl();
END DruckeMenue;

PROCEDURE BoxerRl() RAISES {As.Terminate}=
  BEGIN
    REPEAT
      TRY 
        DruckeMenue();

        (* Frage Benutzer nach seiner Auswahl *)
        SIO.PutText("Auswahl: ");
        auswahl := SIO.GetChar();
        dummy := SIO.GetLine(); (* Lies RETURN aus dem Eingabepuffer! *)
        SIO.Nl();
  
        CASE auswahl OF
        |  'F', 'f' => boxer := Boxer.LeseEin("Boxer Einfuegen"); SIO.Nl();
                         Boxen.EinfuegenBoxerRL(boxer);
                      
        |  'L', 'l' => boxer := Boxer.LeseEin("Boxer Loeschen"); SIO.Nl();
                       Boxen.LoescheBoxerRL(boxer);
                     
        |  'G', 'g' => gewinner := Boxer.LeseEin("Sieger des Kampfes"); SIO.Nl();
                       verlierer := Boxer.LeseEin("Verlierer des Kampfes"); SIO.Nl();
                       Boxen.AktualisiereRL(gewinner, verlierer);
                  
        |  'Z', 'z' => Boxen.DruckeRL();
  
        |  'E', 'e' => (* Nichts machen, gleich ist ohnehin alles zu Ende! *)
        ELSE
          SIO.PutLine("Ungueltiger Befehl!");
        END (* CASE *)

    EXCEPT
      | As.Violated =>
                SIO.PutLine ("*********** Fehler beim Bearbeiten der Boxrangliste ************");
                RAISE As.Terminate;
      | SIO.Error => SIO.PutLine("SIO-Fehler!!");
    END;

    UNTIL (auswahl = 'e') OR (auswahl = 'E');
  END BoxerRl;

BEGIN 
  As.EnableAssertions();
  TRY
     BoxerRl();
  EXCEPT
    |As.Terminate =>
      SIO.PutLine("***  Programm wird beendet wegen des obigen Fehlers ***");
   END;
END BoxerRl.

