INTERFACE Boxen;

(* Schnittstelle des Objektmoduls zur Verwaltung einer Boxrangliste.
   Autor           : Moritz Schnizler, Antje Nowack
   Umgebung        : PM3, Windows 95
   Erstellt        : 06.01.99  Letzte Aenderung: 15.01.2001 *)

IMPORT Boxer;  (* Importiere den ADT Boxer *)
IMPORT Assertion AS As;

PROCEDURE VollRL(): BOOLEAN;
(* Prueft, ob noch Platz fuer wenigstens einen Boxer in der Rangliste ist. *)


PROCEDURE BoxerExistiertRL(boxer: Boxer.T): BOOLEAN;
(* Prueft, ob der angegebene Boxer in der Rangliste enthalten ist. *)


PROCEDURE EinfuegenBoxerRL(boxer: Boxer.T) RAISES{As.Violated};
(* Fuegt den gegebenen Boxer am Ende der Rangliste ein. Vorbedingung:
   Der Boxer ist noch nicht in der Rangliste enthalten und die Rangliste
   ist noch nicht voll. 
   Vorbedingung: Der einzufuegende Boxer darf noch nicht in der Liste enthalten sein.
    Nachbedingung: Der Boxer muss in der Liste enthalten sein. *)


PROCEDURE LoescheBoxerRL(boxer:Boxer.T) RAISES{As.Violated};
(* Loescht den gegebenen Boxer aus der Rangliste. Vorbedingung:
   Der Boxer ist in der Rangliste enthalten.
   Vorbedingung: Der zu loeschende Boxer muss in der Rangliste enthalten sein.
    Nachbedingung: Der zu loeschende Boxr darf nach dem Loeschen nicht mehr in der Rangliste enthalten sein. *)      


PROCEDURE AktualisiereRL(gewinner, verlierer: Boxer.T) RAISES{As.Violated};
(* Aendert die Rangfolge in der Rangliste entsprechend dem gegebenen 
   Kampfergebnis (Gewinner, Verlierer). Vorbedingung: Gewinner und 
   Verlierer sind in der Rangliste enthalten  
   Vorbedingung: Gewinner und Verlierer muessen beide in der Liste enthalten sein. *)


PROCEDURE DruckeRL();
(* Gibt die Rangliste in absteigender Rangfolge aus *)
  
END Boxen.