MODULE Boxer;

(* Implementiert den ADT fuer die Daten eines Boxers.
   Autor           : Moritz Schnizler, RWTH Aachen
   Umgebung        : SRC-Modula-3 rel. 3.6, Windows NT 4.0
   Erstellt        : 06.01.99  Letzte Aenderung: 07.01.99 *)

IMPORT SIO;  (* Importiere Operationen fuer Ein-/Ausgabe *)
IMPORT Text; (* Importiere Operationen fuer Textmanipulation *)

TYPE Name = RECORD
              vorname : TEXT;
              nachname: TEXT;
            END;

     (* Definiere nach aussen nur als abstrakten Datentyp sichtbaren
        Datentyp fuer Boxer *)

     REVEAL T = BRANDED REF RECORD
                  name       : Name;
                  nation     : TEXT;
                  gewicht    : CARDINAL;
                END;

PROCEDURE LeseEin(nachricht: TEXT): T=
(* Fragt den Benutzer nach den Daten eines Boxers und gibt
   anschliessend einen entsprechenden Boxer zurueck. *)

VAR resultat: T;
    dummy   : TEXT;

BEGIN
  (* Erzeuge einen neuen Boxer auf der Halde *)
  resultat := NEW(T);

  (* Erfrage Daten vom Benutzer *)
  SIO.PutLine(nachricht);
  SIO.PutText("Nachname   : "); 
  resultat^.name.nachname := SIO.GetLine();
  SIO.PutText("Vorname    : "); 
  resultat^.name.vorname := SIO.GetLine();
  SIO.PutText("Nation     : "); 
  resultat^.nation       := SIO.GetLine();
  SIO.PutText("Gewicht: ");
  resultat^.gewicht := SIO.GetInt();
  
  (* Lies RETURN nach Gewicht aus der Eingabe! *)
  dummy := SIO.GetLine();                  
  
  RETURN resultat;
END LeseEin;


PROCEDURE Drucke(boxer: T)=
(* Gibt die Daten des Boxers aus. *)
BEGIN
  SIO.PutText(boxer^.name.nachname & "  ");
  SIO.PutText(boxer^.name.vorname & "  ");
  SIO.PutText("Nation ");
  SIO.PutText(boxer^.nation & "  ");
  SIO.PutText("Gewicht ");
  SIO.PutInt(boxer^.gewicht);
  SIO.Nl();
END Drucke;


PROCEDURE Gleich(boxerA, boxerB: T): BOOLEAN=
(* Prueft, ob die beiden Boxer gleich sind. *)
BEGIN
  RETURN ((Text.Equal(boxerA^.name.vorname, boxerB^.name.vorname)) AND
          (Text.Equal(boxerA^.name.nachname, boxerB^.name.nachname)) AND
          (Text.Equal(boxerA^.nation, boxerB^.nation)) AND
          (boxerA^.gewicht = boxerB^.gewicht));
END Gleich;

BEGIN
END Boxer.