MODULE Vokalersetzung EXPORTS Main;

(* Dieses Programm ersetzt in einem Text jeden Vokal durch einen anderen. 
   Autor : Th. von der Maen, RWTH Aachen
   Umgebung : PM-3, Windows 2000
   Erstellt : 06.11.2000
   Letzte Aenderung: 15.11.2000
*)


IMPORT SIO;
IMPORT Text;

(* Diese Hilfsfunktion schneidet das erste Zeichen des bergebenen Textes ab und liefert
den Rest zurck *)
PROCEDURE Rest(string: TEXT) : TEXT =
BEGIN
  RETURN (Text.Sub(string, 1));
END Rest;


(* Diese Hilfsfunktion gibt das erste Zeichen eines bergebenen Textes als CHAR zurck *)
PROCEDURE ErstesZeichen(string: TEXT): CHAR =
BEGIN
  RETURN (Text.GetChar(string, 0));
END ErstesZeichen;


(* Diese Funktion berprft das erste Zeichen des bergebenen Textes. Falls das Zeichen ein Vokal ist,
wird dieser nach dem geforderten Schema ersetzt. *)
PROCEDURE Ersetze(string: TEXT): TEXT =
BEGIN
  IF Text.Empty(string) THEN
    RETURN ("");
  ELSE
    IF ErstesZeichen(string) = 'a' THEN
      RETURN ("e" & Ersetze(Rest(string)));    
    ELSIF ErstesZeichen(string) = 'A' THEN
      RETURN ("E" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'e' THEN
      RETURN ("i" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'E' THEN
      RETURN ("I" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'i' THEN
      RETURN ("o" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'I' THEN
      RETURN ("O" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'o' THEN
      RETURN ("u" & Ersetze(Rest(string))); 
    ELSIF ErstesZeichen(string) = 'O' THEN
      RETURN ("U" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'u' THEN
      RETURN ("a" & Ersetze(Rest(string)));
    ELSIF ErstesZeichen(string) = 'U' THEN
      RETURN ("A" & Ersetze(Rest(string)));
    ELSE
      RETURN (Text.FromChar(ErstesZeichen(string)) & Ersetze(Rest(string)));
    END;
  END;
END Ersetze;


(* Das Hauptmodul liest einen Text von der Tastatur ein und bergibt diesen der Funktion "Ersetze" *)
BEGIN
  SIO.PutText("Geben Sie einen Text ein: ");
  SIO.PutText("Ergebnis: " & Ersetze(SIO.GetLine()));
  SIO.Nl();
END Vokalersetzung.