MODULE Kubikwurzel EXPORTS Main;

(* Dieses Programm berechnet approximativ die Kubikwurzel fr eine gegebene Zahl unter Anwendung
des Newton-Verfahrens
   Autor    : Th. von der Maen, RWTH Aachen
   Umgebung : PM-3, Windows 2000
   Erstellt : 06.11.2000
   Letzte Aenderung: 15.11.2000
*)

IMPORT SIO;


(* Diese Funktion berechnet des absoluten Wert der Differenz aus y^3 und x und gibt diesen zurck *)
PROCEDURE Abstand(y, x : REAL) : REAL =
BEGIN
  RETURN (ABS((y * y * y) - x));
END Abstand;


(* Diese Funktion prft, ob der Wert des Parameters Abstand kleiner als die Fehlerschranke e ist.
In diesem Fall wird TRUE zurckgegeben, ansonsten FALSE *)
PROCEDURE GutGenug(abstand, e : REAL) : BOOLEAN =
BEGIN
  IF (abstand < e) THEN
    RETURN TRUE;
    ELSE
      RETURN FALSE;
  END;
END GutGenug;


(* Diese Funktion berechnet einen Nherungswert y als Kubikwurzel aus einer Zahl x und testet, ob der Nherungswert unter einer vordefinierten Schranke fehler liegt. *)
PROCEDURE BerechneKubikwurzel(x, y, fehler: REAL) : REAL =
BEGIN
  IF GutGenug(Abstand(y, x), fehler) THEN
    RETURN (y);
  ELSE
    RETURN (BerechneKubikwurzel(x, ((x / (y * y)) + (2.0 * y)) / 3.0, fehler));
  END;
END BerechneKubikwurzel;


(* Diese Prozedur gibt die Kubikwurzel einer Zahl unter Verwendung der Funktion BerechneKubikwurzel aus. *)
PROCEDURE Newton(zahl: REAL): REAL =
BEGIN
  SIO.PutText("Die Kubikwurzel lautet: ");
  RETURN (BerechneKubikwurzel(zahl, zahl, 0.0001));
END Newton;


(* Das Hauptprogramm list eine Zahl von der Tastatur ein und bergibt diese an die Prozedur Newton zur Berechnung der Kubikwurzel aus dieser Zahl. *)
BEGIN
  SIO.PutText("Zahl: ");
  SIO.PutReal(Newton(SIO.GetReal()));
  SIO.Nl();
END Kubikwurzel.