MODULE Lebewesen EXPORTS Main;

(* Dieses Programm berechnet die Anzahl der ausserirdischen Lebewesen in einem gegeben Jahr n
des Newton-Verfahrens
   Autor    : Th. von der Maen, RWTH Aachen
   Umgebung : PM-3, Windows 2000
   Erstellt : 06.11.2000
   Letzte Aenderung: 16.11.2000
*)

IMPORT SIO;


(* Diese Hilfsfunktion berechnet die Anzahl der Lebewesen eines Jahres *)
PROCEDURE BerechneAnzahl(anzahl: INTEGER): INTEGER =
BEGIN
  RETURN (anzahl + (anzahl DIV 3));
END BerechneAnzahl;


(* Diese Funktion liefert unter Verwendung der Funktion "BerechneAnzahl", die Anzahl der Lebewesen eines Jahres. Die Anzahl ergibt sich aus der Anzahl der Lebewesen des vorherigen Jahres, vermindert um diejenigen, die ihre maximale Lebensdauer berschritten haben. *)
PROCEDURE AnzahlLebewesen(jahr: INTEGER): INTEGER =
BEGIN
  IF jahr < 0 THEN
    RETURN 0;
  ELSIF jahr = 0 THEN
    RETURN 3;
  ELSE
    RETURN BerechneAnzahl(AnzahlLebewesen(jahr-1) - Neugeborene(jahr-6));
  END;
END AnzahlLebewesen;


(* Diese Hilfsfunktion ermittelt die Neugeborenen Lebewesen eines Jahres *)
PROCEDURE Neugeborene(jahr: INTEGER): INTEGER =
BEGIN
  IF jahr < 0 THEN
    RETURN 0;
  ELSIF jahr = 0 THEN
    RETURN 3;
  ELSE
    RETURN ((AnzahlLebewesen(jahr-1) - Neugeborene(jahr-6)) DIV 3);
  END;
END Neugeborene;

BEGIN
  SIO.PutText("Geben Sie die das Jahr ein: ");
  SIO.PutInt(AnzahlLebewesen(SIO.GetInt()));
  SIO.Nl();
END Lebewesen.