MODULE Potenz EXPORTS Main;

(* Ausgabe von b^n fuer Eingabe b und n
   Autor: Antje Nowack
   Umgebung: PM3, Windows95
   Erstellt: 22. 11. 2000
   Letzte Aenderung: 22. 11. 2000
*)

IMPORT SIO;

(* Die folgenden (Hilfs-)Prozedur wird fuer die Ein- und 
Ausgabe benutzt *)

PROCEDURE Eingabe() =

VAR b, n : REAL;

BEGIN 
  SIO.PutText("Bitte geben Sie die Basis ein: ");
  b := SIO.GetReal();
  SIO.Nl();
  SIO.PutText("Bitte geben Sie den Exponenten ein: ");
  n := SIO.GetReal();
  SIO.Nl();
  SIO.PutText("Das Ergebnis lautet: ");
  SIO.PutReal(Potenz(b,n));
  SIO.Nl();
END Eingabe;

(* Die folgende Funktion gibt zu einer natuerlichen Zahl 
an, ob sie gerade ist. *)

PROCEDURE IsEven (n : REAL) : BOOLEAN  =
BEGIN
  IF n = 0.0 THEN RETURN TRUE;
  ELSIF n = 1.0 THEN RETURN FALSE;
  ELSE RETURN (IsEven(n-2.0));
  END;
END IsEven ;

(* Die folgende Funktion liefert zu einer
Zahl ihr Quadrat. *)

PROCEDURE Quadrat(x : REAL) : REAL =
BEGIN
  RETURN x*x;
END Quadrat;

(* Die folgende Funktion gibt b^n fuer Eingabe b und n
aus. Sie ist rekursiv definiert. Die Idee dahinter ist 
(b^(n/2))^2 = b^n fuer gerade n. Fuer n ungerade gilt: 
b^n = b * (b^(n-1)) und n-1 ist gerade. Auf die Potenz
mit (n-1) im Exponenten kann die Regel fuer gerade n 
benutzt werden. *)

PROCEDURE Potenz(b, n: REAL) : REAL =
BEGIN
  IF n=0.0 THEN 
    RETURN 1.0;
  ELSIF IsEven(n) THEN
(* Rekursiver Aufruf im Fall, dass n gerade ist *)
    RETURN Quadrat(Potenz(b, n/2.0));
  ELSE
(* Rekursiver Aufruf im Fall, dass n ungerade ist *)
    RETURN (b * Potenz(b, n -1.0));
  END;
END Potenz;

BEGIN
  Eingabe();
END Potenz.