MODULE Potenz EXPORTS Main;

(* Ausgabe von b^n fuer Eingabe b und n
   Autor: Antje Nowack
   Umgebung: PM3, Windows95
   Erstellt: 22. 11. 2000
   Letzte Aenderung: 22. 11. 2000
*)

IMPORT SIO;

(* Die folgenden (Hilfs-)Prozedur wird fuer die Ein- und 
Ausgabe benutzt *)

PROCEDURE Eingabe() =

VAR a, b, n : REAL;

BEGIN 
  SIO.PutText("Bitte geben Sie die Basis ein: ");
  b := SIO.GetReal();
  SIO.Nl();
  SIO.PutText("Bitte geben Sie den Exponenten ein: ");
  n := SIO.GetReal();
  SIO.Nl();
  SIO.PutText("Das Ergebnis lautet: ");
  Potenz_iter(b, n, a);  
  SIO.PutReal(a);
  SIO.Nl();
END Eingabe;

(* Die folgende Funktion gibt zu einer natuerlichen Zahl 
an, ob sie gerade ist. Sie arbeitet iterativ. *)

PROCEDURE IsEven (n : REAL) : BOOLEAN  =
BEGIN
  WHILE n >= 0.0 DO
   IF n = 0.0 THEN RETURN TRUE;
   ELSIF n = 1.0 THEN RETURN FALSE;
   ELSE n := n - 2.0;
   END;
  END;
END IsEven ;

(* Die folgende Funktion liefert zu einer
Zahl ihr Quadrat. *)

PROCEDURE Quadrat(x : REAL) : REAL =
BEGIN
  RETURN x*x;
END Quadrat;

(* Die folgende Prozedur gibt b^n fuer Eingabe b und n
aus. Sie arbeitet iterativ. Die Idee dahinter ist 
(b^(n/2))^2 = b^n fuer gerade n. Fuer n ungerade gilt: 
b^n = b * (b^(n-1)) und n-1 ist gerade. Auf die Potenz
mit (n-1) im Exponenten kann die Regel fuer gerade n 
benutzt werden.
Das Ergebnis wird in a akkumuliert.
*)

PROCEDURE Potenz_iter(b, n: REAL; VAR a: REAL) =
VAR m, pot : REAL;
BEGIN
(* Hilfsvariablen werden initialisiert. *)
(* m haelt den aktuellen Exponenten *)
  m := n; 
(* pot haelt die aktuelle Basis *)
  pot := b;
(* Die Ausgabe wird mit 1 initialisiert. Daher findet keine separate
Abfrage statt, ob der Exponent gleich 0 ist. *)
  a := 1.0;
(* While-Schleife wird im Fall, dass der Eponent nicht 0 ist ausgefuehrt *)
  WHILE m > 0.0 DO
(* Wenn m gerade ist, wird die entsprechende Regel angewandt *)
    IF IsEven(m) THEN  
      pot := Quadrat(pot);
      m := m/2.0;
    ELSE 
(* ... ebenso im ungeraden Fall *)
      a := a * pot;
      m := m - 1.0;      
    END;
  END;
END Potenz_iter;

BEGIN
 Eingabe();
END Potenz.