MODULE Matrizen EXPORTS Main;

(* 
   Dieses Programm multipliziert zwei (5 x 5) Matrizen und
   gibt die Ergebnismatrix aus.

   Autor           : Moritz Schnizler, RWTH Aachen
   Umgebung        : PM 3, Windows NT 4.0
   Erstellt        : 23.11.00
   Letzte Aenderung: 23.11.00
*)


IMPORT SIO; (* Importiere notwendige Ein-/Ausgabeoperationen *)
IMPORT Fmt; (* Importiere Operationen, um die Ausgabe zu formatieren *)

CONST N = 5; (* Konstante fr den maximalen Index n *)


(* Notwendige Datentypen fr eine (n x n) Matrix *)

TYPE Zeile  = [1 .. N];
     Spalte = [1 .. N];
     Matrix = ARRAY Zeile, Spalte OF REAL; 


(* Deklaration der beiden Ausgangsmatrizen und Initialisierung mit Feldaggregaten *)

VAR a := Matrix {ARRAY Zeile OF REAL {1.0, 2.0, 3.0, 4.0, 5.0},
                 ARRAY Zeile OF REAL {1.5, 2.5, 3.5, 4.5, 5.5},
                 ARRAY Zeile OF REAL {1.3, 2.3, 3.3, 4.3, 5.3},
                 ARRAY Zeile OF REAL {1.7, 2.7, 3.7, 4.7, 5.7},
                 ARRAY Zeile OF REAL {1.9, 2.9, 3.9, 4.9, 5.9}};

    b := Matrix {ARRAY Zeile OF REAL {2.0, 3.0, 4.0, 5.0, 6.0},
                 ARRAY Zeile OF REAL {2.5, 3.5, 4.5, 5.5, 6.5},
                 ARRAY Zeile OF REAL {2.3, 3.3, 4.3, 5.3, 6.3},
                 ARRAY Zeile OF REAL {2.7, 3.7, 4.7, 5.7, 6.7},
                 ARRAY Zeile OF REAL {2.9, 3.9, 4.9, 5.9, 6.9}};


PROCEDURE MatrixMult(a, b: Matrix): Matrix =
(* Multipliziert die gegebenen Matrizen a und b, liefert die
   Ergebnismatrix als Rckgabewert *)
VAR c: Matrix;

BEGIN
  FOR i := FIRST(Zeile) TO LAST(Zeile) DO
    FOR j := FIRST(Spalte) TO LAST(Spalte) DO

      c [i, j] := 0.0;
      FOR k := FIRST(Spalte) TO LAST(Spalte) DO
        c [i, j] := c [i, j] + a[i, k] * b[k, j];
      END;

    END;
  END;

  RETURN c;   
END MatrixMult;


PROCEDURE MatrixAusgeben(a: Matrix) =
(* Gibt die komplette Matrix elementweise aus *)

BEGIN
  FOR i := FIRST(Zeile) TO LAST(Zeile) DO
    FOR j := FIRST(Spalte) TO LAST(Spalte) DO
      SIO.PutText(MatElementFormat(a [i, j])); SIO.PutText("  ");
    END;
    SIO.Nl();
  END;
END MatrixAusgeben;


PROCEDURE MatElementFormat(r: REAL): TEXT =
(* Formatiere die REAL-Zahl mit Fixpunktnotation und 3 Nachkommastellen
   rechtsbuendig in einem festen Feld mit 8 Stellen *)
(* War in der Aufgabe NICHT verlangt! *)

BEGIN
  RETURN Fmt.Pad(Fmt.Real(r, Fmt.Style.Fix, 3), 8, ' ', Fmt.Align.Right);
END MatElementFormat;


BEGIN
  (* Ausgeben der zwei zu multiplizierenden Matrizen *)
  MatrixAusgeben(a);
  SIO.PutLine("                        *");
  MatrixAusgeben(b);
  SIO.PutLine("                        =");
  (* Ausgabe des Resultats *)
  MatrixAusgeben(MatrixMult(a, b));
END Matrizen.