INTERFACE Instrument;

  (* Das Objektmodul Instrument ist eine billige Moeglichkeit, um die
     Zweige eines Programms zu instrumentieren. Allerdings ist die
     hier gewaehlte Loesung auf maximal 99 verwaltbare Zweige begrenzt.

     Autor           : Moritz Schnizler, RWTH Aachen
     Umgebung        : PM 3, Windows 2000
     Erstellt        : 19.12.00
     Letzte Aenderung: 20.12.00 *)

  CONST MaxZweige = 99; (* Maximale Anzahl der verwaltbaren Zweige *)

  PROCEDURE Initialisiere(zweige: [1..MaxZweige]);
  (* Initialisiert das Objektmodul mit der Anzahl der Programmzweige *)
  
  PROCEDURE ZaehleZweig(i: CARDINAL);
  (* Erhoeht den Zaehler fuer Programmzweig i um eins *)

  PROCEDURE ZaehlerAusgeben();
  (* Gibt die ermittelten Zaehlerwerte auf dem Bildschirm aus *)

  PROCEDURE Ueberdeckungsgrad(): REAL;
  (* Gibt den Grad der Zweigueberdeckung in Prozent zurueck *)

END Instrument.